package com.fp.persistence.pgeneral.report;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import java.io.Serializable;
import javax.persistence.Table;
import com.fp.dto.hb.HibernateBean;
import javax.persistence.Version;
import java.lang.reflect.Field;
import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TGENEREPORT*/
@Entity(name="TgeneReport")
@Table(name="TGENEREPORT")
public class TgeneReport extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TgeneReport
*/
@EmbeddedId
private TgeneReportKey pk;
@Column(name="DESCRIPTION", nullable=false)

/**
* Descripcion del Reporte
*/
private String description;

@Version
@Column(name="RECORDVERSION", nullable=true)

/**
* Optimistic locking del registro
*/
private Integer recordversion;

@Column(name="REPORTNAME", nullable=true)

/**
* Nombre del reporte a ejecutar
*/
private String reportname;

@Column(name="PATH", nullable=true)

/**
* Ubicacion del reporte.
*/
private String path;

/**Contructor por defecto*/
public TgeneReport(){
}
/**Contructor de TgeneReport
@param pPk Clave Primaria del entity
@param pDescription Descripcion del Reporte
*/
public TgeneReport(TgeneReportKey pPk,String pDescription){
 this();
 pk=pPk;
 description=pDescription;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TgeneReport
*/
public static TgeneReport find(EntityManager pEntityManager,TgeneReportKey pKey) throws Exception{
    TgeneReport obj = pEntityManager.find(TgeneReport.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TgeneReport
@return El objeto que referencia a la Clave primaria de TgeneReport
*/
public TgeneReportKey getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TgeneReport
@param pPk El objeto que referencia a la nueva Clave primaria de TgeneReport
*/
public void setPk(TgeneReportKey pPk){
  pk=pPk;
}
/**Obtiene el valor de description
@return valor de description*/
public String getDescription(){
  return description;
}
/**Fija el valor de description
@param pDescription nuevo Valor de description*/
public void setDescription(String pDescription){
  description=pDescription;
}

/**Obtiene el valor de recordversion
@return valor de recordversion*/
public Integer getRecordversion(){
  return recordversion;
}
/**Fija el valor de recordversion
@param pRecordversion nuevo Valor de recordversion*/
public void setRecordversion(Integer pRecordversion){
  recordversion=pRecordversion;
}

/**Obtiene el valor de reportname
@return valor de reportname*/
public String getReportname(){
  return reportname;
}
/**Fija el valor de reportname
@param pReportname nuevo Valor de reportname*/
public void setReportname(String pReportname){
  reportname=pReportname;
}

/**Obtiene el valor de path
@return valor de path*/
public String getPath(){
  return path;
}
/**Fija el valor de path
@param pPath nuevo Valor de path*/
public void setPath(String pPath){
  path=pPath;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TgeneReport))return false;
    TgeneReport that = (TgeneReport) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementación del metodo hashCode de la la entidad TgeneReport
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementación de la creación de un bean en blanco TgeneReport
*/
public Object createInstance(){
 TgeneReport instance=new TgeneReport();	
 instance.setPk(new TgeneReportKey());
 return instance;
}
/**Clona la entidad TgeneReport
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TgeneReport p=(TgeneReport)this.clone();
  p.setPk((TgeneReportKey)this.pk.cloneMe());
  return p;
}
}
